#include "tlang.h"
#include <stdio.h>
dict_t* dict_create()
{
    dict_t* dict = (dict_t*)malloc(sizeof(dict_t));
    dict->capacity =256;
    dict->items=(kvp_t*)malloc(sizeof(kvp_t) * 256);
    dict->length = 0;
    return dict;
    
}
void _dict_setkvp(dict_t* dict,kvp_t kvp)
{
    int i;
    for(i=0;i<dict->length;i++)
    {
        if(strcmp(dict->items[i].key,kvp.key) == 0)
        {
            dict->items[i].value = kvp.value;
            return;
        }
    }    
    if(dict->length + 1 > dict->capacity)
    {
        dict->capacity = dict->length + 128;
        dict->items=(kvp_t*)realloc(dict,dict->capacity * sizeof(kvp_t));

    }
    dict->length++;
    size_t len = strlen(kvp.key);
    dict->items[i].key = (char*)malloc(sizeof(char) * (len+1));
    strncpy(dict->items[i].key,kvp.key,len);
    dict->items[i].key[len] = 0;
    dict->items[i].value = kvp.value;
}
void dict_setkvp(dict_t* d,kvp_t kvp)
{
    tobject_addref(kvp.value);
     if(dict_haskey(d,kvp.key))
     {

           tobject_rmref(dict_getkvp(d,kvp.key)->value);
     }
        
    _dict_setkvp(d,kvp);
}
kvp_t* dict_getkvp(dict_t* dict,char* key)
{
    int i;
    kvp_t* kvp=NULL;
    for(i=0;i<dict->length;i++)
    {
        if(strcmp(dict->items[i].key,key) == 0)
        {
            kvp = &dict->items[i];
        }
    }
    return kvp;
}
bool dict_haskey(dict_t* dict,char* key)
{
    int i;
    
    for(i=0;i<dict->length;i++)
    {
        if(strcmp(dict->items[i].key,key) == 0)
        {
            return true;
        }
    }
    return false;
}
void dict_rm(dict_t* dict,char* key)
{
    int i;
    for(i=0;i<dict->length;i++)
    {
        if(strcmp(dict->items[i].key,key)==0)
        {
            free(dict->items[i].key);
            tobject_rmref(dict->items[i].value);
            break;
        }
    }
    dict->length--;
    for(;i<dict->length;i++)
    {
        dict->items[i] = dict->items[i+1];
    }
}
void dict_free(dict_t* dict)
{
    int i;
    for(i=0;i<dict->length;i++)
    {
        free(dict->items[i].key);
        tobject_rmref(dict->items[i].value);
    }
    free(dict->items);
    free(dict);
}