#include "tlang.h"
tobject_t* __node_function_call_execute(node_t* n,scope_t* s,retarg_t* retArg)
{
    
    list_tobject_t args;
    list_create(s->rt,&args,0);
    
    int i;
    for(i = 0;i< n->data.function_call_node.count;i++)
    {
        node_t* a =n->data.function_call_node.args[i];
        retarg_t retArg2;
        list_add(&args,a->execute(a,s,&retArg2));
    }
    char* name = string_dupp(n->data.function_call_node.name);
    tobject_t* fname = s->getvariable(s,name);
    free(name);
    tobject_t* o = tobject_call(s,fname,&args);
    o->count++; //ensures this object is not freed when freeing list
    list_free(&args);
    o->count--;
    return o;
} 

void __node_function_call_free(node_t* node)
{
   node_t** args= node->data.function_call_node.args;
   int i;
   for(i=0;i<node->data.function_call_node.count;i++)
   {
        node_free(args[i]);
   }
   free(args);
   string_free(node->data.function_call_node.name);
}

node_t* node_function_call_create(string_t* name)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = functioncallnode;
    n->data.function_call_node.count = 0;
    n->data.function_call_node.name = string_dups(name);
    n->data.function_call_node.capacity=64;
    n->data.function_call_node.args=(node_t**)malloc(sizeof(node_t*) * n->data.scope_node.capacity);
    n->execute = __node_function_call_execute;
    n->free = __node_function_call_free;
    
    return n;
}
void node_function_call_add(node_t* fc,node_t* arg)
{
     if(fc->data.function_call_node.count + 128 >fc->data.scope_node.capacity)
    {
        fc->data.function_call_node.capacity = fc->data.function_call_node.count + 128;
        fc->data.function_call_node.args=(node_t**)realloc(fc->data.function_call_node.args,fc->data.function_call_node.capacity * sizeof(node_t*));

    } 
    fc->data.function_call_node.args[fc->data.function_call_node.count++]=arg;
}