

#include "tlang.h"
#include <math.h>
#include <stdint.h>
tobject_t* __kvp_as_str(tobject_t* parent_obj,tobject_t* argument_obj)
{
    if(parent_obj->type != tdict) return NULL;
    if(argument_obj->type == tstring)
    {
        char* p = string_dupp(argument_obj->data.string);
        if(dict_haskey(parent_obj->data.dict,p))
        {
            tobject_t* v = dict_getkvp(parent_obj->data.dict,p)->value;
            free(p);
            return v;
        }
        free(p);
    }
    return NULL;
}

tobject_t* __node_getarray_execute(node_t* n,scope_t* s,retarg_t* retArg)
{
    node_t* parent=n->data.array_node.parent;
    tobject_t* parent_obj = parent->execute(parent,s,retArg);
    tobject_t* o = NULL;
    node_t* argument =n->data.array_node.argument;
    tobject_t* argument_obj = argument->execute(argument,s,retArg);

    if(parent_obj->type == tlist)
    {
        //argument is expected to be a number
        if(argument_obj->type == tnumber)
        {
            //yay it is a number
            int pos = (int)argument_obj->data.number;
            if(pos >= 0 && pos <= parent_obj->data.list.length)
            {
                o = parent_obj->data.list.items[pos];
                
            }
        }
    }
    if(parent_obj->type == tstring)
    {
        //argument is expected to be a number
        if(argument_obj->type == tnumber)
        {
            //yay it is a number
            int pos = (int)argument_obj->data.number;
            if(pos >= 0 && pos <= parent_obj->data.string->length)
            {
                o = tobject_char(s->rt,parent_obj->data.string->text[pos]);
            }
            
        }
    }
    if(parent_obj->type == tdict)
    {
        if(dict_haskey(parent_obj->data.dict,"at"))
        {
            tobject_t* obj=dict_getkvp(parent_obj->data.dict,"at")->value;
            if(obj->type == tinternalmethod || obj->type == texternalmethod)
            {
                list_tobject_t args;
                argument_obj->count++;
                list_add(&args,argument_obj);
                o=tobject_call(s,obj,&args);
                o->count++;

                list_free(&args);
                o->count--;
                argument_obj->count--;
            }else{
                //get kvp value as string
                o=__kvp_as_str(parent_obj,argument_obj);
            }
        }else{
                o=__kvp_as_str(parent_obj,argument_obj);

        }
    }

    if(o == NULL)
    {
        o = tobject_basic(s->rt,tundef);
    }
    o->count++;
    argument_obj->count++;
    tobject_freeifzero(parent_obj);
    argument_obj->count--;
    tobject_freeifzero(argument_obj);
    o->count--;
    return o;
} 
void __kvp_set(tobject_t* parent_obj,tobject_t* argument_obj,tobject_t* variable)
{
    if(parent_obj->type != tdict) return;
    if(argument_obj->type == tstring)
    {
        char* p = string_dupp(argument_obj->data.string);
        if(dict_haskey(parent_obj->data.dict,p))
        {
            kvp_t k;
            k.key = p;
            k.value = variable;
            dict_setkvp(parent_obj->data.dict,k);
        }
        free(p);
    }
    
}

void __node_setarray_execute(node_t* n,tobject_t* variable_obj,scope_t* s)
{
    node_t* parent=n->data.array_node.parent;
    retarg_t arg;
    arg.isContinue=false;
    arg.isBreaking=false;
    arg.isReturning=false;
    tobject_t* parent_obj = parent->execute(parent,s,&arg);
    
    node_t* argument =n->data.array_node.argument;
    tobject_t* argument_obj = argument->execute(argument,s,&arg);

    if(parent_obj->type == tlist)
    {
        //argument is expected to be a number
        if(argument_obj->type == tnumber)
        {
            //yay it is a number
            int pos = (int)argument_obj->data.number;
            if(pos >= 0 && pos <= parent_obj->data.list.length)
            {
                list_set(&parent_obj->data.list,pos,variable_obj);
                
            }
        }
    }
  /*  if(parent_obj->type == tstring)
    {
        //argument is expected to be a number
        if(argument_obj->type == tnumber)
        {
            //yay it is a number
            int pos = (int)argument_obj->data.number;
            if(pos >= 0 && pos <= parent_obj->data.string->length)
            {
                o = tobject_char(s->rt,parent_obj->data.string->text[pos]);
            }
            
        }
    }*/
    if(parent_obj->type == tdict)
    {
        if(dict_haskey(parent_obj->data.dict,"setAt"))
        {
            tobject_t* obj=dict_getkvp(parent_obj->data.dict,"setAt")->value;
            if(obj->type == tinternalmethod || obj->type == texternalmethod)
            {
                list_tobject_t args;
               variable_obj->count++;
                parent_obj->count++;
                argument_obj->count++;
                obj->count++;
                list_add(&args,argument_obj);
                list_add(&args,variable_obj);
                

               tobject_t* o2= tobject_call(s,obj,&args);
                tobject_freeifzero(o2);
               
                list_free(&args);
                 variable_obj->count--;
                 parent_obj->count--;
                argument_obj->count--;
                obj->count--;
            }else{
                //get kvp value as string
                __kvp_set(parent_obj,argument_obj,variable_obj);
            }
        }else{
                __kvp_set(parent_obj,argument_obj,variable_obj);

        }
    }

 
    variable_obj->count++;
    argument_obj->count++;
    tobject_freeifzero(parent_obj);
    argument_obj->count--;
    tobject_freeifzero(argument_obj);
    variable_obj->count--;
 
} 

void __node_getarray_free(node_t* node)
{
    node_free(node->data.array_node.argument);
    node_free(node->data.array_node.parent);
}

node_t* node_getarray_create(node_t* parent,node_t* argument)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = getarraynode;
    n->execute = __node_getarray_execute;
    n->free = __node_getarray_free;
    n->data.array_node.set = __node_setarray_execute;
    n->data.array_node.argument = argument;
    n->data.array_node.parent = parent;
    return n;
}
