#include "tlang.h"
#include <math.h>
#include <stdint.h>

tobject_t* __ls_get_current(runtime_t* rt,void* ptr,list_tobject_t* ls)
{
    ittr_t* ittr=(ittr_t*)ptr;
    return ittr_current(ittr);
}
tobject_t* __ls_movenext(runtime_t* rt,void* ptr,list_tobject_t* ls)
{
    ittr_t* ittr=(ittr_t*)ptr;
    
    bool v=ittr_movenext(ittr);
    tobject_t* o = tobject_create(rt);
    o->type = tbool;
    o->data.boolean = v;
    return o;
}
tobject_t* __ls_reset(runtime_t* rt,void* ptr,list_tobject_t* ls)
{
     ittr_t* ittr=(ittr_t*)ptr;
     ittr_reset(ittr);
     return tobject_basic(rt,tnull);

}
tobject_t* __ls_free(runtime_t* rt,void* ptr,list_tobject_t* ls)
{
     ittr_t* ittr=(ittr_t*)ptr;
     ittr_free(ittr);
     return tobject_basic(rt,tnull);

}
tobject_t* __node_getmember_execute(node_t* n,scope_t* s,retarg_t* retArg)
{
    node_t* parent=n->data.variable_node.parent;
    tobject_t* parent_obj = parent->execute(parent,s,retArg);

    char* vn = string_dupp(n->data.variable_node.name);
    string_t* getvars = string_create();
    string_appendp(getvars,"get");
    string_appends(getvars,n->data.variable_node.name);
    char* getvar = string_dupp(getvars);
    string_free(getvars);
    tobject_t* o = NULL;
    if(parent_obj->type == tlist)
    {
        if(strcmp(vn,"length") == 0 || strcmp(vn,"count") == 0)
        {
            o = tobject_create(s->rt);
            o->type = tnumber;
            o->data.number = parent_obj->data.list.length;
        }
        if(strcmp(vn,"ittr") == 0)
        {
            o = tobject_create(s->rt);
            o->type = tdict;
            dict_t* d= dict_create();
            ittr_t* ittr=list_ittr(s->rt,parent_obj);
            runtime_create_method_on_dict(d,"getcurrent",s->rt,ittr,__ls_get_current,NULL);
            runtime_create_method_on_dict(d,"movenext",s->rt,ittr,__ls_movenext,NULL);
            runtime_create_method_on_dict(d,"reset",s->rt,ittr,__ls_reset,NULL);
            runtime_create_method_on_dict(d,"dispose",s->rt,ittr,__ls_free,NULL);
            
            
            o->data.dict= d;
        }
        
    }
    if(parent_obj->type == tdict)
    {
        if(dict_haskey(parent_obj->data.dict,getvar))
        {
            tobject_t* _o = dict_getkvp(parent_obj->data.dict,getvar)->value;
            list_tobject_t arg;
            list_create(s->rt,&arg,0);
            tobject_t* o2=tobject_call(s,_o,&arg);
            o2->count++;
            list_free(&arg);
            o2->count--;
            o= o2;
        }else
        if(dict_haskey(parent_obj->data.dict,vn))
        {
            o = dict_getkvp(parent_obj->data.dict,vn)->value;
            
        }
    }
    if(parent_obj->type == tnumber)
    {
        if(strcmp(vn,"abs") == 0)
        {
            double val=fabs(parent_obj->data.number);
            
            o = tobject_create(s->rt);
            o->type = tnumber;
            o->data.number = val;
        }
        if(strcmp(vn,"int") == 0)
        {
            int64_t val=(int64_t)parent_obj->data.number;
            
            o = tobject_create(s->rt);
            o->type = tnumber;
            o->data.number = val;
        }
        
    }
    if(parent_obj->type == tstring)
    {
        if(strcmp(vn,"number") == 0)
        {
            char* ptr=string_dupp(parent_obj->data.string);
            double num=0;
            if(string_isnumber(parent_obj->data.string,&num))
            {
                o = tobject_create(s->rt);
                o->data.number = num;
                o->type = tnumber;
            }else{
                o=tobject_basic(s->rt,tnull);
            }
            
            free(ptr);
        }
        if(strcmp(vn,"ittr") == 0)
        {
            o = tobject_create(s->rt);
            o->type = tdict;
            dict_t* d= dict_create();
            ittr_t* ittr=string_ittr(s->rt,parent_obj->data.string);
            runtime_create_method_on_dict(d,"getcurrent",s->rt,ittr,__ls_get_current,NULL);
            runtime_create_method_on_dict(d,"movenext",s->rt,ittr,__ls_movenext,NULL);
            runtime_create_method_on_dict(d,"reset",s->rt,ittr,__ls_reset,NULL);
            runtime_create_method_on_dict(d,"dispose",s->rt,ittr,__ls_free,NULL);
            
            
            o->data.dict= d;
        }
        if(strcmp(vn,"length") == 0 || strcmp(vn,"count") == 0)
        {
            o = tobject_create(s->rt);
            o->type = tnumber;
            o->data.number = parent_obj->data.string->length;
            
        }
        if(strcmp(vn,"boolean") == 0)
        {
            o = tobject_create(s->rt);
            o->type = tbool;
            o->data.boolean = string_samep(parent_obj->data.string,"true");
        }
    }
    free(vn);
    free(getvar);
    if(o == NULL)
    {
        o = tobject_basic(s->rt,tundef);
    }
    o->count++;
    tobject_freeifzero(parent_obj);
    o->count--;
    return o;
} 
void __node_setmember_execute(node_t* n,tobject_t* o,scope_t* s)
{
    node_t* parent=n->data.variable_node.parent;
    //node_t* myN = n->data.variable_node.value;
    retarg_t arg;
    arg.isContinue=false;
    arg.isBreaking=false;
    arg.isReturning=false;
    tobject_t* parent_obj = parent->execute(parent,s,&arg);

    char* vn = string_dupp(n->data.variable_node.name);
    string_t* getvars = string_create();
    string_appendp(getvars,"set");
    string_appends(getvars,n->data.variable_node.name);
    char* getvar = string_dupp(getvars);
    string_free(getvars);
   
    
  
    if(parent_obj->type == tdict)
    {
        if(dict_haskey(parent_obj->data.dict,getvar))
        {
            tobject_t* _o = dict_getkvp(parent_obj->data.dict,getvar)->value;
            list_tobject_t arg;
            list_create(s->rt,&arg,0);
            list_add(&arg,o);
            tobject_freeifzero(tobject_call(s,_o,&arg));
            list_free(&arg);
            
        }else 
        {
            kvp_t kvp;
            kvp.key = vn;
            kvp.value = o;
            dict_setkvp(parent_obj->data.dict,kvp);
            
        }
    }
    free(vn);
    free(getvar);
    
    tobject_freeifzero(parent_obj);
   
} 

void __node_getmember_free(node_t* node)
{
     string_free(node->data.variable_node.name);
     node_free(node->data.variable_node.parent);
}

node_t* node_getmember_create(string_t* name,node_t* parent)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = getmembernode;
    n->execute = __node_getmember_execute;
    n->free = __node_getmember_free;
    n->data.variable_node.name = string_dups(name);
    n->data.variable_node.parent = parent;
    n->data.variable_node.set = __node_setmember_execute;
    return n;
}
