#include "tlang.h"
typedef struct 
{
    tobject_t* o;
    scope_t* s;
} __dict_ittr;
bool _dict_movenext(ittr_t* ittr)
{
    __dict_ittr* o = (__dict_ittr*)ittr->ptr;
    
    if(o->o->type != tdict) return false;
    if(!dict_haskey(o->o->data.dict,"movenext")) return false;
    tobject_t* j = dict_getkvp(o->o->data.dict,"movenext")->value;
    if(j->type == texternalmethod || j->type == tinternalmethod)
    {
         list_tobject_t ob;
        list_create(o->s->rt,&ob,0);
        tobject_t* res= tobject_call(o->s,j,&ob);
        bool res2=tobject_tobool(res);
        tobject_freeifzero(res);
        list_free(&ob);
        return res2;
    }
    return false;
}
void _dict_free(ittr_t* ittr)
{
     __dict_ittr* o = (__dict_ittr*)ittr->ptr;
    
    if(o->o->type != tdict) return;
    if(!dict_haskey(o->o->data.dict,"dispose")) return;
    tobject_t* j = dict_getkvp(o->o->data.dict,"dispose")->value;
    if(j->type == texternalmethod || j->type == tinternalmethod)
    {
        list_tobject_t ob;
        list_create(o->s->rt,&ob,0);
        tobject_t* res= tobject_call(o->s,j,&ob);
        tobject_freeifzero(res);
        list_free(&ob);
        
    }
}
tobject_t* _dict_getcurrent(ittr_t* ittr)
{
     __dict_ittr* o = (__dict_ittr*)ittr->ptr;
    
    if(o->o->type != tdict) return tobject_basic(o->s->rt,tnull);
    if(!dict_haskey(o->o->data.dict,"getcurrent") && !dict_haskey(o->o->data.dict,"current")) return tobject_basic(o->s->rt,tnull);
    tobject_t* res=NULL;
    if(dict_haskey(o->o->data.dict,"getcurrent")){
    tobject_t* j = dict_getkvp(o->o->data.dict,"getcurrent")->value;
    if(j->type == texternalmethod || j->type == tinternalmethod)
    {
        list_tobject_t ob;
        list_create(o->s->rt,&ob,0);
        res= tobject_call(o->s,j,&ob);
       
        list_free(&ob);
        
    }
    }
    if(res == NULL && dict_haskey(o->o->data.dict,"current"))
    {
        res = dict_getkvp(o->o->data.dict,"current")->value;
    }
    if(res != NULL)
    {
        return res;
    }
    return tobject_basic(o->s->rt,tnull);
}

void _dict_reset(ittr_t* ittr)
{
     __dict_ittr* o = (__dict_ittr*)ittr->ptr;
    
    if(o->o->type != tdict) return;
    if(!dict_haskey(o->o->data.dict,"reset")) return;
    tobject_t* j = dict_getkvp(o->o->data.dict,"reset")->value;
    if(j->type == texternalmethod || j->type == tinternalmethod)
    {
        list_tobject_t ob;
        list_create(o->s->rt,&ob,0);
        tobject_t* res= tobject_call(o->s,j,&ob);
        tobject_freeifzero(res);
        list_free(&ob);
        
    }
}
ittr_t* ittr_dict(tobject_t* obj,scope_t* s)
{
    ittr_t* i=NULL;
    if(obj->type = tdict)
    {
        tobject_t* d=NULL;
        if(dict_haskey(obj->data.dict,"getittr"))
        {
            kvp_t* kvp=dict_getkvp(obj->data.dict,"getittr");
            if(kvp->value->type == texternalmethod || kvp->value->type == tinternalmethod)
            {
                list_tobject_t o;
                list_create(s->rt,&o,0);
                tobject_t* res=tobject_call(s,kvp->value,&o);
                list_free(&o);
                if(res->type == tdict)
                {
                    d = res;
                } else {
                    //sorry but we have to free you
                    tobject_freeifzero(res);
                }
            }
        }
        if(d == NULL)
        {
             if(dict_haskey(obj->data.dict,"ittr"))
             {
                kvp_t* kvp=dict_getkvp(obj->data.dict,"ittr");
                if(kvp->value->type == tdict)
                {
                    d = kvp->value;
                }
            
             }
        }

        if(d != NULL)
        {
            __dict_ittr* ee = (__dict_ittr*)malloc(sizeof(__dict_ittr));
            ee->o = d;
            ee->s = s;
            i=ittr_create(ee,_dict_movenext,_dict_reset,_dict_getcurrent,_dict_free);

        }
    }
    return i;
}
ittr_t* ittr_obj(tobject_t* obj,scope_t* s)
{
    if(obj->type == tdict)
    {
        return ittr_dict(obj,s);
    }
    if(obj->type == tstring)
    {
        return string_ittr(s->rt,obj->data.string);
    }
    if(obj->type == tlist)
    {
        return list_ittr(s->rt,obj);
    }
    return NULL;
}
ittr_t* ittr_create(void* ptr,ittr_movenext_t movenext,ittr_reset_t reset,ittr_getcurrent_t current,ittr_reset_t free)
{
    ittr_t* ittr = (ittr_t*)malloc(sizeof(ittr_t));
    ittr->ptr=ptr;
    ittr->movenext = movenext;
    ittr->reset = reset;
    ittr->getcurrent = current;
    ittr->free = free;
    return ittr;
}
void ittr_reset(ittr_t* ittr)
{
    ittr->reset(ittr);
}
tobject_t* ittr_current(ittr_t* ittr)
{
    return ittr->getcurrent(ittr);
}
bool ittr_movenext(ittr_t* ittr)
{
    return ittr->movenext(ittr);
}
void ittr_free(ittr_t* ittr)
{
    ittr->free(ittr);
    free(ittr);
}