#include "tlang.h"
lextokenlist_t* lextokenlist_create()
{
    lextokenlist_t* list = (lextokenlist_t*)malloc(sizeof(lextokenlist_t));
    list->capacity = 128;
    list->count = 0;
    list->tokens = (lextoken_t*)malloc(sizeof(lextoken_t) * list->capacity);
    return list;
}
void lextokenlist_ensure(lextokenlist_t* a)
{
    if(a->count + 1 > a->capacity)
    {
        a->capacity = a->count + 128;
        a->tokens=(lextoken_t*)realloc(a->tokens,a->capacity * sizeof(lextoken_t));

    }
}


void lextokenlist_addstring(lextokenlist_t* ls,string_t* str)
{
    ls->count++;
    lextokenlist_ensure(ls);
    lextoken_t* lt=ls->tokens+(ls->count-1);
    lt->isString=true;
    lt->isChar = false;
    lt->text = string_dups(str);
}
void lextokenlist_additem(lextokenlist_t* ls,string_t* str)
{
    ls->count++;
    lextokenlist_ensure(ls);
    lextoken_t* lt=ls->tokens+(ls->count-1);
    lt->isString=false;
    lt->isChar = false;
    lt->text = string_dups(str);
}
void lextokenlist_addchar(lextokenlist_t* ls,char c)
{
    ls->count++;
    lextokenlist_ensure(ls);
    lextoken_t* lt=ls->tokens+(ls->count-1);
    lt->isString=false;
    lt->isChar = true;
    lt->text = string_create();
    string_appendc(lt->text,c);
}
void lextokenlist_free(lextokenlist_t* t)
{
    int i;
    for(i=0;i<t->count;i++)
    {
        string_free(t->tokens[i].text);
    }
    free(t->tokens);
    free(t);
}
bool lextoken_isitem(lextoken_t t,char* c)
{
    if(t.isChar || t.isString) return false;
    return string_samep(t.text,c);
}