#include "tlang.h"

typedef struct {
    tobject_t* ls;
    int pos;
    tobject_t* current;
    runtime_t* rt;
} listittr_t;
void _list_free(ittr_t* ittr)
{
    listittr_t* ittrData = (listittr_t*)ittr->ptr;
    
    tobject_rmref(ittrData->current);
    tobject_rmref(ittrData->ls);
    free(ittrData);
}
tobject_t* _list_getcurrent(ittr_t* ittr)
{
     listittr_t* ittrData = (listittr_t*)ittr->ptr;
    return ittrData->current;
}
void _list_reset(ittr_t* ittr)
{
     listittr_t* ittrData = (listittr_t*)ittr->ptr;
     ittrData->pos=-1;
}
bool _list_movenext(ittr_t* ittr)
{
    listittr_t* ittrData = (listittr_t*)ittr->ptr;
    ittrData->pos++;
    if(ittrData->pos<ittrData->ls->data.list.length)
    {
        tobject_rmref(ittrData->current);
        ittrData->current = ittrData->ls->data.list.items[ittrData->pos];
        tobject_addref(ittrData->current);
        return true;
    }
    return false;
}
ittr_t* list_ittr(runtime_t* rt,tobject_t* ls)
{
    listittr_t* myittr=(listittr_t*)malloc(sizeof(listittr_t));
    myittr->pos = -1;
    myittr->rt = rt;
    myittr->ls = ls;
    tobject_addref(myittr->ls);
    myittr->rt = rt;
    myittr->current = tobject_basic(rt,tnull);
    tobject_addref(myittr->current);
    return ittr_create(myittr,_list_movenext,_list_reset,_list_getcurrent,_list_free);
}