#if defined(HW_RVL)
#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include "tlang.h"
static void *xfb = NULL;
static GXRModeObj *rmode = NULL;
extern void __reg_wpad(runtime_t* rt);
void __reg_wii(runtime_t* rt)
{
	__reg_wpad(rt);
}
//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------

	// Initialise the video system
	VIDEO_Init();

    fatInitDefault();
	// Obtain the preferred video mode from the system
	// This will correspond to the settings in the Wii menu
	rmode = VIDEO_GetPreferredMode(NULL);

	// Allocate memory for the display in the uncached region
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	// Initialise the console, required for printf
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	// Set up the video registers with the chosen mode
	VIDEO_Configure(rmode);

	// Tell the video hardware where our display memory is
	VIDEO_SetNextFramebuffer(xfb);

	// Make the display visible
	VIDEO_SetBlack(FALSE);

	// Flush the video register changes to the hardware
	VIDEO_Flush();

	// Wait for Video setup to complete
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();


	// The console understands VT terminal escape codes
	// This positions the cursor on row 2, column 0
	// we can use variables for this with format codes too
	// e.g. printf ("\x1b[%d;%dH", row, column );
	printf("\x1b[2;0H");
    FILE* f = fopen("app.tlang","r");
    
    if(f)
    {
        runtime_t* rt=runtime_init();
		runtime_register_std(rt);
        runtime_register(rt,__reg_wii);
		
        string_t* s = string_create();
        string_read(s,f,fread);
        runtime_load(rt,s);    
        string_free(s);

        fclose(f);
		printf("Loaded Script\n");
        tobject_t* o = runtime_exec(rt);
        
        tobject_freeifzero(o);
        runtime_free(rt);
    }else{
        printf("\n\n\n\n\tNo Tlang Script found\n");
        WPAD_Init();
        while(1) {

		// Call WPAD_ScanPads each loop, this reads the latest controller states
		    WPAD_ScanPads();

		// WPAD_ButtonsDown tells us which buttons were pressed in this loop
		// this is a "one shot" state which will not fire again until the button has been released
		    u32 pressed = WPAD_ButtonsDown(0);

		// We return to the launcher application via exit
		    if ( pressed & WPAD_BUTTON_HOME ) exit(0);

		// Wait for the next frame
		    VIDEO_WaitVSync();
	    }
    }


	return 0;
}
#endif