#include "tlang.h"
typedef struct 
{
    int i;
    runtime_t* rt;
    lextokenlist_t* ls;
} parser_t;

void liststr_create(list_string_t* l)
{
    l->capacity=128;
    l->count = 0;
    l->strings = (tobject_t**)malloc(l->capacity * sizeof(string_t*));
}
void liststr_add(list_string_t* l,string_t* s)
{
    
    if(l->count + 2 > l->capacity)
    {
        l->capacity = l->count + 128;
        l->strings=(tobject_t**)realloc(l->strings,l->capacity * sizeof(string_t*));

    } 
    l->strings[l->count++] = string_dups(s);
}

node_t* parse_expression(parser_t* p);
node_t* parse_assignable(parser_t* p);
node_t* parse_lor(parser_t* p);
node_t* parse_land(parser_t* p);
node_t* parse_bor(parser_t* p);
node_t* parse_xor(parser_t* p);
node_t* parse_band(parser_t* p);
node_t* parse_eq(parser_t* p);
node_t* parse_ro(parser_t* p);
node_t* parse_shift(parser_t* p);
node_t* parse_sum(parser_t* p);
node_t* parse_factor(parser_t* p);
node_t* parse_value(parser_t* p);

node_t* __parser_parse2(parser_t* p,bool isFirst,bool inCase)
{
    if(p->i>= p->ls->count) return node_const_number_create(0);
    if(lextoken_isitem(p->ls->tokens[p->i],"{") || isFirst)
    {
        if(!isFirst)
                p->i++;
        node_t* scope = node_scope_create(isFirst);
        while(p->i<p->ls->count && !lextoken_isitem(p->ls->tokens[p->i],"}"))
        {
            if(inCase && (lextoken_isitem(p->ls->tokens[p->i],"case") || lextoken_isitem(p->ls->tokens[p->i],"default")))
            {
               
                break;
            }
            node_scope_append(scope,parse_expression(p));
            //scopeNode.Body.Add(ParseExpression(tokens,ref i));
                    if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i],";"))
                    {
                        p->i++;
                    }

        }
        if(!inCase)
        p->i++;
        return scope;
    }
    return parse_assignable(p);
}
node_t* __parser_parse(parser_t* p,bool isFirst)
{   
    return __parser_parse2(p,isFirst,false);
}
node_t* parse_assignable(parser_t* p)
{
    node_t* myExpression = parse_lor(p);
      while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "=") || lextoken_isitem(p->ls->tokens[p->i], "+=") || lextoken_isitem(p->ls->tokens[p->i], "-=") || lextoken_isitem(p->ls->tokens[p->i], "*=") || lextoken_isitem(p->ls->tokens[p->i], "/=") || lextoken_isitem(p->ls->tokens[p->i], "%=") || lextoken_isitem(p->ls->tokens[p->i], "|=") || lextoken_isitem(p->ls->tokens[p->i], "&=") || lextoken_isitem(p->ls->tokens[p->i], "^=") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,parse_lor(p),true);
                   
                 }
                if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "+=")){
                    p->i++;
                  
                    myExpression = node_setvariable_create(myExpression,node_add_create(myExpression,parse_lor(p)),false);
                   
                 }
                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "-=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_sub_create(myExpression,parse_lor(p)),false);
                   
                 }
                  if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "*=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_multiply_create(myExpression,parse_lor(p)),false);
                   
                 }
                  if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "/=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_divide_create(myExpression,parse_lor(p)),false);
                   
                 }
                   if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "%=")){
                    p->i++;
                    
                    myExpression = node_setvariable_create(myExpression,node_modulo_create(myExpression,parse_lor(p)),false);
                   
                 }
                 
                  if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "|=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_bitwiseor_create(myExpression,parse_lor(p)),false);
                   
                 }
                  if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "&=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_bitwiseand_create(myExpression,parse_lor(p)),false);
                   
                 }
                  if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "^=")){
                    p->i++;
                    myExpression = node_setvariable_create(myExpression,node_xor_create(myExpression,parse_lor(p)),false);
                   
                 }
                   
              
                
            } 
   
    return myExpression;
}
node_t* parse_lor(parser_t* p)
{
    node_t* myExpression = parse_land(p);
        while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "||") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "||")){
                    p->i++;
                    myExpression = node_logicalor_create(myExpression,parse_land(p));
                   
                 }
               
                   
              
                
            } 
   
    
    return myExpression;
}
node_t* parse_land(parser_t* p)
{
    node_t* myExpression = parse_bor(p);
         while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "&&") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "&&")){
                    p->i++;
                    myExpression = node_logicaland_create(myExpression,parse_bor(p));
                   
                 }
               
                   
              
                
            } 
   
    return myExpression;
}
node_t* parse_bor(parser_t* p)
{
    node_t* myExpression = parse_xor(p);
        while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "|") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "|")){
                    p->i++;
                    myExpression = node_bitwiseor_create(myExpression,parse_xor(p));
                   
                 }
               
                   
              
                
            } 
   
    return myExpression;
}
node_t* parse_xor(parser_t* p)
{
    node_t* myExpression = parse_band(p);
    while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "^") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "^")){
                    p->i++;
                    myExpression = node_xor_create(myExpression,parse_band(p));
                   
                 }
               
                   
              
                
            } 
    return myExpression;
}
node_t* parse_band(parser_t* p)
{
    node_t* myExpression = parse_eq(p);
    while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "&") ))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "&")){
                    p->i++;
                    myExpression = node_bitwiseand_create(myExpression,parse_eq(p));
                   
                 }
               
                   
              
                
            } 
    return myExpression;
}
node_t* parse_eq(parser_t* p)
{
    node_t* myExpression = parse_ro(p);
   
     while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "==") || lextoken_isitem(p->ls->tokens[p->i], "!=")))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "==")){
                    p->i++;
                    myExpression = node_eq_create(myExpression,parse_ro(p));
                   
                 }
               
                   
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], "!="))
                    {
                        p->i++;
                        myExpression = node_neq_create(myExpression,parse_ro(p));
                    }
               
                
            } 
    return myExpression;
    return myExpression;
}
node_t* parse_ro(parser_t* p)
{
    node_t* myExpression = parse_shift(p);
      while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "<") || lextoken_isitem(p->ls->tokens[p->i], ">") || lextoken_isitem(p->ls->tokens[p->i], "<=") || lextoken_isitem(p->ls->tokens[p->i], ">=")))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "<")){
                    p->i++;
                    myExpression = node_lessthan_create(myExpression,parse_shift(p));
                   
                 }
                if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "<=")){
                    p->i++;
                    myExpression = node_lessthanequal_create(myExpression,parse_shift(p));
                   
                 }
                   
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], ">"))
                    {
                        p->i++;
                        myExpression = node_greaterthan_create(myExpression,parse_shift(p));
                    }
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], ">="))
                    {
                        p->i++;
                        myExpression = node_greaterthanequal_create(myExpression,parse_shift(p));
                    }
               
                
            } 
   
    return myExpression;
}
node_t* parse_shift(parser_t* p)
{
    node_t* myExpression = parse_sum(p);
       while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "<<") || lextoken_isitem(p->ls->tokens[p->i], ">>")))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "<<")){
                    p->i++;
                    myExpression = node_leftshift_create(myExpression,parse_sum(p));
                   
                 }
               
                   
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], ">>"))
                    {
                        p->i++;
                        myExpression = node_rightshift_create(myExpression,parse_sum(p));
                    }
               
                
            } 
   
    return myExpression;
}
node_t* parse_sum(parser_t* p)
{
    
    node_t* myExpression = parse_factor(p);
     while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "+") || lextoken_isitem(p->ls->tokens[p->i], "-")))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "+")){
                    p->i++;
                    myExpression = node_add_create(myExpression,parse_factor(p));
                   
                 }
               
                   
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], "-"))
                    {
                        p->i++;
                        myExpression = node_sub_create(myExpression,parse_factor(p));
                    }
               
                
            } 
    return myExpression;
}
node_t* parse_factor(parser_t* p)
{
    node_t* myExpression = parse_value(p);
     while(p->i<p->ls->count && (lextoken_isitem(p->ls->tokens[p->i], "*") || lextoken_isitem(p->ls->tokens[p->i], "/") || lextoken_isitem(p->ls->tokens[p->i], "%")))
            {
                

                 if(p->i<p->ls->count && lextoken_isitem(p->ls->tokens[p->i], "*")){
                    p->i++;
                    myExpression = node_multiply_create(myExpression,parse_value(p));
                   
                 }
               
                   
                    if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], "/"))
                    {
                        p->i++;
                        myExpression = node_divide_create(myExpression,parse_value(p));
                    }
                     if(p->i<p->ls->count  && lextoken_isitem(p->ls->tokens[p->i], "%"))
                    {
                        p->i++;
                        myExpression = node_modulo_create(myExpression,parse_value(p));
                    }
               
                
            } 
    return myExpression;
}
node_t* parse_value(parser_t* p)
{
    
    if(p->i >= p->ls->count) return node_const_number_create(0);
    lextoken_t token=p->ls->tokens[p->i++]; //6
    if(token.isString) return node_const_string_create(token.text);
    if(token.isChar) {
        char c=' ';
        if(token.text->length > 0)
        {
            c = token.text->text[0];
        }
        return node_const_char_create(c);
    }
    if(string_samep(token.text,"brk") || string_samep(token.text,"break"))
    {
        return node_break_create(true);
    }
    if(string_samep(token.text,"cont") || string_samep(token.text,"continue"))
    {
        return node_break_create(false);
    }
    if(string_samep(token.text,"ret") || string_samep(token.text,"return"))
    {
        return node_return_create(parse_expression(p));
    }
    if(string_samep(token.text,"case"))
    {
        //case <expression> : body
        node_t* exp= parse_expression(p);
        if(p->i < p->ls->count && string_samep(p->ls->tokens[p->i].text,":"))
        {
            p->i++;
        }
        return node_case_create(exp,__parser_parse2(p,true,true));
    }
     if(string_samep(token.text,"default"))
    {
        //default: body
    
        if(p->i < p->ls->count && string_samep(p->ls->tokens[p->i].text,":"))
        {
            p->i++;
        }
        return node_default_create(__parser_parse2(p,true,true));
    }
    if(string_samep(token.text,"-"))
    {
        
        return node_negative_create(parse_value(p));
    }
    if(string_samep(token.text,"~"))
    {
        //printf("GOT HERE\n");
        return node_bitwisenot_create(parse_value(p));
    }
    if(string_samep(token.text,"!"))
    {
        return node_not_create(parse_value(p));
    }
    int64_t num;
    //for now try parsing number
   
    if(string_islong(token.text,&num))
    {
       
        if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text, ".") && !p->ls->tokens[p->i].isChar && !p->ls->tokens[p->i].isString)
        {
            p->i++;
            string_t* _s = string_create();
            string_appendn(_s,num);
            string_appendc(_s,'.');
            string_appends(_s,p->ls->tokens[p->i].text);
            double dbl;
            if(string_isnumber(_s,&dbl))
            {
                string_free(_s);
                return node_const_number_create(dbl);
            }
            string_free(_s);
        }else{
         return node_const_number_create(num);
        }
    } else {
        if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"("))
        {
            //funcs and stuff
            if(string_samep(token.text,"func"))
            {
                list_string_t strs;
                liststr_create(&strs);
                p->i++;
                while(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,")"))
                {
                    if(string_samep(p->ls->tokens[p->i].text,",")) {p->i++;continue;}
                    if(p->i<p->ls->count)
                    {
                        node_t* n = parse_expression(p);
                        if(n->type == getvariablenode)
                        {
                            liststr_add(&strs,n->data.variable_node.name);
                        }
                        node_free(n);
                    }
                }
                p->i++;
                return node_closure_create(strs,parse_expression(p));

            }
            else if(string_samep(token.text,"for"))
            {
                p->i++;
                node_t* init = NULL;
                node_t* condition = NULL;
                node_t* inc = NULL;
                node_t* body = NULL;
                //tokens[i].Text != ")"
                
                if(p->i<p->ls->count && (!string_samep(p->ls->tokens[p->i].text,")") || !string_samep(p->ls->tokens[p->i].text,";")))
                {
                            init = parse_expression(p);
                }
                if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,";"))
                        p->i++;
                if(p->i<p->ls->count && (!string_samep(p->ls->tokens[p->i].text,")") || !string_samep(p->ls->tokens[p->i].text,";")))
                {
                    condition = parse_expression(p);
                }
                if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,";"))
                        p->i++;
                if(p->i<p->ls->count && (!string_samep(p->ls->tokens[p->i].text,")") || !string_samep(p->ls->tokens[p->i].text,";")))
                {
                    inc = parse_expression(p);
                }
                if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,")"))
                        p->i++;
                if(p->i<p->ls->count)
                    body = parse_expression(p);

                return node_for_loop_create(init,condition,inc,body);
            }
            else if(string_samep(token.text,"each"))
            {
                p->i++;
                        node_t* ls = parse_expression(p);
                        string_t* _s02 = string_create();
                        string_appendp(_s02,"item");
                        node_t* name  = node_getvariable_create(_s02);
                        string_free(_s02);
                        if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,":"))
                        {
                            p->i++;
                            if(ls->type == getvariablenode)
                            {
                                node_free(name);
                                name = ls;
                            }
                            
                            ls = parse_expression(p);
                        }
                        p->i++;
                        if(p->i<p->ls->count)
                        {
                            return node_eachloop_create(name,ls,parse_expression(p));
                        }
            }
            else if(string_samep(token.text,"switch"))
            {
            
                p->i++;
                node_t* condition = parse_expression(p);
                p->i++;
                node_t* body=NULL;
                if(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,";"))
                {
                    body = parse_expression(p);
                }else{
                    body = node_const_undef_create();
                }
                if(body->type == scopenode)
                {
                    
                    body->data.scope_node.switch_arg = condition;
                }else{
                    node_free(condition);
                }
                return body;
            }
            else if(string_samep(token.text,"while") || string_samep(token.text,"do"))
            {
                p->i++;
                node_t* condition = parse_expression(p);
                p->i++;
                node_t* yes = NULL;
                if(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,";"))
                {
                    yes = parse_expression(p);
                }else{
                    yes = node_const_undef_create();
                }
                return node_while_loop_create(condition,yes,string_samep(token.text,"do"));
            }
            else if(string_samep(token.text,"if"))
            {
                p->i++;
                node_t* condition = parse_expression(p);
                p->i++;
                node_t* yes = NULL;
                node_t* no = NULL;
                if(p->i < p->ls->count && !string_samep(p->ls->tokens[p->i].text,"else"))
                {
                    yes = parse_expression(p);
                }else{
                    yes = node_const_undef_create();
                }
                if(p->i < p->ls->count && string_samep(p->ls->tokens[p->i].text,"else"))
                {
                    p->i++;
                    no = parse_expression(p);
                }
                else {
                    no = node_const_undef_create();
                }
                return node_if_create(condition,yes,no);

            }
            else {
                p->i++;
                node_t* ret = node_function_call_create(token.text);
                while(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,")") )
                {

                        if(string_samep(p->ls->tokens[p->i].text,",")) {p->i++;continue;}

                        if(p->i<p->ls->count)
                        {
                            node_function_call_add(ret,parse_expression(p));
                            
                        }

                }
                p->i++;
                while(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"["))
                {
                            
                          p->i++;
                            node_t* arg = parse_expression(p);
                         p->i++;
                            ret = node_getarray_create(ret,arg);
                            
                            
                }
                
                    while(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"."))
                    {
                        p->i++;
                        
                        lextoken_t token2 = p->ls->tokens[p->i++];

                        if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"("))
                        {
                             p->i++;
                             ret = node_method_call_create(ret,token2.text);
                             //args = new List<Node>();
                             //function call baby
                             while(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,")"))
                             {

                                if(string_samep(p->ls->tokens[p->i].text,",")) {p->i++;continue;}

                                if(p->i<p->ls->count)
                                {
                                    node_method_call_add(ret,parse_expression(p));
                                    
                                }

                            }
                            p->i++;
                            
                        }
                        else if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"["))
                        {
                            p->i++;
                            node_t* arg = parse_expression(p);
                            p->i++;
                            ret = node_getarray_create(ret,arg);
                            
                        }
                        else{
                            ret = node_getmember_create(token2.text,ret);
                            
                        }

                    }
                    if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"++"))
                    {
                       /* var mgvn = ret as GetVariableValue;
                        i++;
                        if(mgvn != null)
                        {
                            return new PostfixIncrementVariableNode(mgvn);
                        }
                        */
                       p->i++;
                       if(ret->type == getvariablenode || ret->type == getarraynode || ret->type == getmembernode)
                       {
                           ret= node_postfix_increment_create(ret);
                       }

                    }
                   if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"--"))
                    {
                       /* var mgvn = ret as GetVariableValue;
                        i++;
                        if(mgvn != null)
                        {
                            return new PostfixIncrementVariableNode(mgvn);
                        }
                        */
                       p->i++;
                       if(ret->type == getvariablenode || ret->type == getarraynode || ret->type == getmembernode)
                       {
                           ret= node_postfix_decrement_create(ret);
                       }

                    }
                    return ret;
                  
            }
        }else {
            node_t* ret = NULL;
            if(string_samep(token.text,"func"))
            {
                node_t* res=node_getvariable_create(p->ls->tokens[p->i].text);
                p->i++;
                if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"("))
                {
                list_string_t strs;
                liststr_create(&strs);
                p->i++;
                while(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,")"))
                {
                    if(string_samep(p->ls->tokens[p->i].text,",")) {p->i++;continue;}
                    if(p->i<p->ls->count)
                    {
                        node_t* n = parse_expression(p);
                        if(n->type == getvariablenode)
                        {
                            liststr_add(&strs,n->data.variable_node.name);
                        }
                        node_free(n);
                    }
                }
                p->i++;
                        
                    return node_setvariable_create(res,node_closure_create(strs,parse_expression(p)),true);
                }
                return node_const_number_create(0);
            }
            
            if(string_samep(token.text,"null"))
            {
                ret=node_const_null_create();
            }else if(string_samep(token.text,"undefined"))
            {
                ret = node_const_undef_create();
            }
            else if(string_samep(token.text,"true"))
            {
                ret = node_const_bool_create(true);
            }else if(string_samep(token.text,"false"))
            {
                ret = node_const_bool_create(false);
            }else {
                ret = node_getvariable_create(token.text);
            }
                  

                while(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"["))
                {
                            
                          p->i++;
                            node_t* arg = parse_expression(p);
                         p->i++;
                            ret = node_getarray_create(ret,arg);
                            
                            
                }
                
                    while(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"."))
                    {
                       
                        p->i++;
                        
                        lextoken_t token2 = p->ls->tokens[p->i++];

                        if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"("))
                        {
                            
                             p->i++;
                             ret = node_method_call_create(ret,token2.text);
                             //args = new List<Node>();
                             //function call baby
                             while(p->i<p->ls->count && !string_samep(p->ls->tokens[p->i].text,")"))
                             {

                                if(string_samep(p->ls->tokens[p->i].text,",")) {p->i++;continue;}

                                if(p->i<p->ls->count)
                                {
                                    node_method_call_add(ret,parse_expression(p));
                                    
                                }

                            }
                            p->i++;
                            
                        }
                        else if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"["))
                        {
                            p->i++;
                            node_t* arg = parse_expression(p);
                            p->i++;
                            ret = node_getmember_create(token2.text,ret);
                            
                            ret = node_getarray_create(ret,arg);
                            
                        }
                        else{
                            ret = node_getmember_create(token2.text,ret);
                            
                        }

                    }
                    if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"++"))
                    {
                       /* var mgvn = ret as GetVariableValue;
                        i++;
                        if(mgvn != null)
                        {
                            return new PostfixIncrementVariableNode(mgvn);
                        }
                        */
                       p->i++;
                       if(ret->type == getvariablenode || ret->type == getarraynode || ret->type == getmembernode)
                       {
                           ret= node_postfix_increment_create(ret);
                       }

                    }
                   if(p->i<p->ls->count && string_samep(p->ls->tokens[p->i].text,"--"))
                    {
                       /* var mgvn = ret as GetVariableValue;
                        i++;
                        if(mgvn != null)
                        {
                            return new PostfixIncrementVariableNode(mgvn);
                        }
                        */
                       p->i++;
                       if(ret->type == getvariablenode || ret->type == getarraynode || ret->type == getmembernode)
                       {
                           ret= node_postfix_decrement_create(ret);
                       }

                    }
                    return ret;
                    

        }
    }

    //return node_const_number_create(f);
    printf("ERROR: END OF PARSE_VALUE_FUNC\n");
    return node_const_undef_create();
}

node_t* parse_expression(parser_t* p)
{
   return __parser_parse(p,false);
}
tobject_t* runtime_eval(runtime_t* rt,string_t* str,scope_t* sc)
{
    if(sc == NULL) sc=rt->globals;
   lextokenlist_t* list=lexer_lex(str);
   parser_t p;
    p.rt = rt;
    p.ls = list;
    p.i = 0;
    node_t* program=__parser_parse(&p,true);
    retarg_t retArg;
    retArg.isBreaking=false;
    retArg.isReturning=false;
    retArg.isContinue=false;
    tobject_t* obj=program->execute(program,sc,&retArg);
    node_free(program);
    return obj;
}
void runtime_load(runtime_t* rt,string_t* str)
{
    
    lextokenlist_t* list=lexer_lex(str);
     parser_t p;
    p.rt = rt;
    p.ls = list;
    p.i = 0;
    rt->program=__parser_parse(&p,true);
    lextokenlist_free(list);

}
void node_free(node_t* n)
{
    n->free(n);

    free(n);
}
