#include "tlang.h"

typedef struct 
{
    scope_t* parent;
    dict_t* vars;
} __subscope_t;

scope_t* __subscope_get_root_scope(scope_t* s)
{
    __subscope_t* sc=(__subscope_t*)s->data;
    return sc->parent->root(sc->parent);

}
tobject_t* __subscope_get_variable(scope_t* s,char* key)
{
    __subscope_t* sc=(__subscope_t*)s->data;
    if(dict_haskey(sc->vars,key) && strcmp(key,"last_ittr") == 0)
    {
        return dict_getkvp(sc->vars,key)->value;
    }
    if(sc->parent->hasvariable(sc->parent,key))
        return sc->parent->getvariable(sc->parent,key);
    if(dict_haskey(sc->vars,key))
        return dict_getkvp(sc->vars,key)->value;
    
    return tobject_basic(s->rt,tundef);
}
bool __subscope_has_variable(scope_t* s,char* key)
{
    __subscope_t* sc=(__subscope_t*)s->data;
    if(dict_haskey(sc->vars,key))
    {
        return true;
    }
    return sc->parent->hasvariable(sc->parent,key);
}
void __subscope_set_variable(scope_t* s,char* key,tobject_t* val)
{
    __subscope_t* sc=(__subscope_t*)s->data;
    if(sc->parent->hasvariable(sc->parent,key) && strcmp(key,"last_ittr") != 0)
    {
        
        sc->parent->setvariable(sc->parent,key,val);

    }else{
       
        kvp_t kvp;
        kvp.key = key;
        kvp.value = val;
        dict_setkvp(sc->vars,kvp);
    }
}
scope_t* __get_subscope(scope_t* s)
{
    __subscope_t* ss = (__subscope_t*)malloc(sizeof(s));
    ss->parent = s;
    tscope_addref(s);
    ss->vars = dict_create();
    scope_t* sub = (scope_t*)malloc(sizeof(scope_t));
    sub->data = ss;
    sub->root = __subscope_get_root_scope;
    sub->subscope = __get_subscope;
    sub->isRoot=false;
    sub->count=1;
    sub->rt = s->rt;
    sub->getvariable = __subscope_get_variable;
    sub->hasvariable = __subscope_has_variable;
    sub->setvariable = __subscope_set_variable;
    return sub;
}
scope_t* __root_get_root_scope(scope_t* s)
{
    return s;
}
bool __root_has_variable(scope_t* s,char* key)
{
    dict_t* dic=(dict_t*)s->data;
    return dict_haskey(dic,key);
}
tobject_t* __root_get_variable(scope_t* s,char* key)
{
    dict_t* dic=(dict_t*)s->data;
    if(dict_haskey(dic,key))
    {
        return dict_getkvp(dic,key)->value;
    }
    return tobject_basic(s->rt,tundef);
}
void __root_set_variable(scope_t* s,char* key,tobject_t* val)
{

    dict_t* dic=(dict_t*)s->data;
   
    kvp_t kvp;
    kvp.key = key;
    kvp.value = val;
    dict_setkvp(dic,kvp);
   
}
void scope_create_root(runtime_t* rt)
{
    if(rt->globals != NULL)
    {
        return;
    }
    rt->globals = (scope_t*)malloc(sizeof(scope_t));
    rt->globals->isRoot=true;
    rt->globals->count=1;
    rt->globals->rt=rt;
    rt->globals->root = __root_get_root_scope;
    rt->globals->hasvariable = __root_has_variable;
    rt->globals->getvariable = __root_get_variable;
    rt->globals->setvariable = __root_set_variable;
    rt->globals->subscope = __get_subscope;
    rt->globals->data = dict_create();
     
}


scope_t* scope_begin(scope_t* s)
{
    return s->subscope(s);
}
scope_t* scope_end(scope_t* s)
{
    if(s->isRoot)
        return s;
    
    __subscope_t* sc=(__subscope_t*)s->data;
    tscope_rmref(s);
    return sc->parent;
}
void tscope_rmref(scope_t* s)
{
    s->count--;
    if(s->count <=0)
    {
        if(!s->isRoot)
        {
            __subscope_t* sc=(__subscope_t*)s->data;
            tscope_rmref(sc->parent);
           
            dict_free(sc->vars);
            free(sc);
            free(s);
        }
        
           

        
    }
}
void tscope_addref(scope_t* s)
{
    s->count++;
}