#include "tlang.h"
tobject_t* __node_scope_execute(node_t* n,scope_t* s,retarg_t* retArg)
{
    tobject_t* switch_data = NULL;
    int state=1;
    if(n->data.scope_node.isSub)
    {
        s=scope_begin(s);
    }
    if(n->data.scope_node.switch_arg != NULL) 
    {
        
        state = 2;
        switch_data = n->data.scope_node.switch_arg->execute(n->data.scope_node.switch_arg,s,retArg);
        tobject_addref(switch_data);
        
        retArg->isBreaking=false;
    }
    tobject_t* obj_data = tobject_basic(s->rt,tnull);
    tobject_addref(obj_data);
    int i;
    

    for(i=0;i<n->data.scope_node.count;i++)
    {
        
        
            node_t* no = n->data.scope_node.items[i];
            if(no->type == casenode)
            {
                
                //check whether it is what we want
                if(state != 1 && switch_data != NULL)
                {
                    
                    if(tobject_sameb(s->rt,switch_data,no->data.two_node_node.left->execute(no->data.two_node_node.left,s,retArg)))
                    {
                        state = 1;
                    }else {
                        state = 0;
                    }
                }
            }
            if(no->type == defaultnode)
            {
                state = 1;
            }
            if(state > 0)
            {
            tobject_t* d=no->execute(no,s,retArg);
            tobject_addref(d); 
            tobject_rmref(obj_data);
            obj_data=d;
                if(retArg->isBreaking || retArg->isReturning || retArg->isContinue)
                {
                    
                    if(switch_data != NULL)
                    {
                        
                        retArg->isBreaking=false;
                    }
                    break;
                }
            }
        }
    
    if(switch_data != NULL)
    {
       
        tobject_rmref(switch_data);
        
    }
    if(n->data.scope_node.isSub)
    {
        s=scope_end(s);
    }
     obj_data->count--; //subtract so we are what we were, can be 0 like usual, should be freed by something
   
    return obj_data;
} 
void __node_scope_free(node_t* node)
{
   node_t** items= node->data.scope_node.items;
   int i;
   for(i=0;i<node->data.scope_node.count;i++)
   {
        node_free(items[i]);
   }
   if(node->data.scope_node.switch_arg)
   {
        node_free(node->data.scope_node.switch_arg);
   }
   free(items);
}

node_t* node_scope_create(bool first)
{
    node_t* n = (node_t*)malloc(sizeof(node_t));
    n->type = scopenode;
    n->data.scope_node.count = 0;
    n->data.scope_node.isSub=!first;
    n->data.scope_node.capacity=64;
    n->data.scope_node.switch_arg = NULL;
    n->data.scope_node.items=(node_t**)malloc(sizeof(node_t*) * n->data.scope_node.capacity);
    n->execute = __node_scope_execute;
    n->free = __node_scope_free;
    
    return n;
}

void node_scope_append(node_t* sc,node_t* n)
{
     if(sc->data.scope_node.count + 128 >sc->data.scope_node.capacity)
    {
        sc->data.scope_node.capacity = sc->data.scope_node.count + 128;
        sc->data.scope_node.items=(node_t**)realloc(sc->data.scope_node.items,sc->data.scope_node.capacity * sizeof(node_t*));

    } 
    sc->data.scope_node.items[sc->data.scope_node.count++]=n;
}