
#include "tlang.h"

typedef struct {
    string_t* str;
    int pos;
    tobject_t* current;
    runtime_t* rt;
} strittr_t;

void _string_free(ittr_t* ittr)
{
    strittr_t* ittrData = (strittr_t*)ittr->ptr;
    string_free(ittrData->str);
    tobject_rmref(ittrData->current);
    free(ittrData);
}
tobject_t* _string_getcurrent(ittr_t* ittr)
{
     strittr_t* ittrData = (strittr_t*)ittr->ptr;
    return ittrData->current;
}
void _string_reset(ittr_t* ittr)
{
     strittr_t* ittrData = (strittr_t*)ittr->ptr;
     ittrData->pos=-1;
}
bool _string_movenext(ittr_t* ittr)
{
    strittr_t* ittrData = (strittr_t*)ittr->ptr;
    ittrData->pos++;
    if(ittrData->pos<ittrData->str->length)
    {
        tobject_rmref(ittrData->current);
        ittrData->current = tobject_create(ittrData->rt);
        ittrData->current->type=tchar;
        ittrData->current->data.chr = ittrData->str->text[ittrData->pos];
        tobject_addref(ittrData->current);
        return true;
    }
    return false;
}
ittr_t* string_ittr(runtime_t* rt,string_t* str)
{
    strittr_t* myittr=(strittr_t*)malloc(sizeof(strittr_t));
    myittr->pos = -1;
    myittr->str = string_dups(str);
    myittr->rt = rt;
    myittr->current = tobject_basic(rt,tnull);
    tobject_addref(myittr->current);
    return ittr_create(myittr,_string_movenext,_string_reset,_string_getcurrent,_string_free);
}