#if defined(HW_RVL)
#include "tlang.h"
#include <wiiuse/wpad.h>
#include <ogcsys.h>
#include <stdio.h>

tobject_t* wpad=NULL;
bool init=false;

tobject_t* __wpad_init_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
{
    
    if(!init)
    {
         init = true;
        return tobject_number(rt,WPAD_Init());
    } 
    return tobject_basic(rt,tnull);
}

tobject_t* __wpad_scanpads_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
{
    s32 s =WPAD_ScanPads();

    
    return tobject_number(rt,s);
}
tobject_t* __wpad_buttonsdown_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
{
    
    if(args->length > 0 && args->items[0]->type == tnumber && args->items[0]->data.number >= 0 && args->items[0]->data.number < 4)
    {
        return tobject_number(rt,WPAD_ButtonsDown((int)args->items[0]->data.number));
        
    }
    return tobject_basic(rt,tnull);
}
tobject_t* __wpad_buttonsup_external_method(runtime_t* rt,void* ptr,list_tobject_t* args)
{
  
    if(args->length > 0 && args->items[0]->type == tnumber && args->items[0]->data.number >= 0 && args->items[0]->data.number < 4)
    {
        return tobject_number(rt,WPAD_ButtonsUp((int)args->items[0]->data.number));
        
    }
    return tobject_basic(rt,tnull);
    
}
void __reg_wpad(runtime_t* rt)
{
    printf("Ready to Register WPAD\n");
    if(wpad ==NULL){
    wpad = tobject_create(rt);
    wpad->type = tdict;
    wpad->data.dict = dict_create();
    wpad->count = 1;
    runtime_create_method_on_object(wpad,"init",rt,NULL,__wpad_init_external_method,NULL);
    runtime_create_method_on_object(wpad,"scanpads",rt,NULL,__wpad_scanpads_external_method,NULL);
    runtime_create_method_on_object(wpad,"buttonsdown",rt,NULL,__wpad_buttonsdown_external_method,NULL);
    runtime_create_method_on_object(wpad,"buttonsup",rt,NULL,__wpad_buttonsup_external_method,NULL);
    
    runtime_create_number_on_object(wpad,"BUTTON_A",rt,WPAD_BUTTON_A);
    runtime_create_number_on_object(wpad,"BUTTON_B",rt,WPAD_BUTTON_B);
    runtime_create_number_on_object(wpad,"BUTTON_1",rt,WPAD_BUTTON_1);
    runtime_create_number_on_object(wpad,"BUTTON_2",rt,WPAD_BUTTON_2);
    runtime_create_number_on_object(wpad,"BUTTON_HOME",rt,WPAD_BUTTON_HOME);
    runtime_create_number_on_object(wpad,"BUTTON_UP",rt,WPAD_BUTTON_UP);
    runtime_create_number_on_object(wpad,"BUTTON_DOWN",rt,WPAD_BUTTON_DOWN);
    runtime_create_number_on_object(wpad,"BUTTON_LEFT",rt,WPAD_BUTTON_LEFT);
    runtime_create_number_on_object(wpad,"BUTTON_RIGHT",rt,WPAD_BUTTON_RIGHT);
    runtime_create_number_on_object(wpad,"BUTTON_PLUS",rt,WPAD_BUTTON_PLUS);
    runtime_create_number_on_object(wpad,"BUTTON_MINUS",rt,WPAD_BUTTON_MINUS);
    }
    //dict_setkvp(wpad->data.dict,);   
    rt->globals->setvariable(rt->globals,"wpad",wpad);
}
#endif