#include <tlang.h>
#include <stdio.h>
void register_funcs(runtime_t* rt)
{

}
int main(int argc,char** argv)
{
    runtime_t* rt = runtime_init();
    runtime_register_std(rt);
    runtime_register(rt,register_funcs);
    
    if(argc < 2)
    {
        string_t* cmd=string_create();
        printf("TLang interactive shell.\nType \"exit\" to exit.\n");
        while(true)
        {
            string_clear(cmd);
            int c=-1;
            printf("> ");
            while((c = fgetc(stdin)) != '\n')
            {
                string_appendc(cmd,(char)c);
            }
            if(string_samep(cmd,"exit")) break;
            runtime_load(rt,cmd);
            tobject_t* o = runtime_exec(rt);
            tobject_freeifzero(o);
            node_free(rt->program);
            rt->program=NULL;
        }
        string_free(cmd);
    }
    else {
        string_t* cmd=string_create();
        
        FILE* f = fopen(argv[1],"r");
        if(f != NULL){
                string_read(cmd,f,(size_t (*)(void*,size_t,size_t,void*))fread);
                fclose(f);
        }
        
        runtime_load(rt,cmd);
        int i;
        for(i=2;i<argc;i++)
        {
            string_t* str = string_create();
            string_appendp(str,argv[i]);
            runtime_add_argument(rt,tobject_string(rt,str));
        }
        tobject_t* o = runtime_exec(rt);
        
        tobject_freeifzero(o);
        
        string_free(cmd);
    }

    runtime_free(rt);
    return 0;
}
